import React from 'react/addons';
const PureRenderMixin = React.addons.PureRenderMixin;
import Immutable from 'immutable';
import { BasicForm } from 'formless';

window.React = React;

const _form = Immutable.fromJS([
    {
        Type: 'email',
        Name: 'Email',
        Label: 'Your email',
        Placeholder: 'Email',
        Validation: ['required', 'email'],
    },
    {
        Type: 'text',
        Name: 'Name',
        Label: 'Your name',
        Placeholder: 'Name',
        Validation: ['required'],
    },
    {
        Type: 'text',
        Name: 'Phone',
        Label: 'Your phone number',
        Placeholder: 'Phone',
    },
    {
        Type: 'textarea',
        Name: 'Message',
        Label: 'Your message',
        Validation: ['required'],
    },
]);


class Contact extends React.Component {

    constructor(props) {
        super(props);
        this.shouldComponentUpdate = PureRenderMixin.shouldComponentUpdate.bind(this);
        this.state = {hasSent: false};
    }

    _onValidSubmit(data) {
        console.log(data, "<<<<<< valid submit");
    }

    renderButton() {
        // const btnEnabled = this.props.isLoading ? false : true;
        return (
            <button type='submit' className='btn btn-inverse'>Send Message</button>
        );
    }

    renderForm() {
        return (
            <div className='row'>
                <div className='col-md-8 desc-block form-fields'>
                    <div className='contact-form padding-bottom-20'>

                        <h2 className='color1'>Contact organiser</h2>
                        <p>Please fill in all of the details below to send a message to the event organiser.</p>

                        <BasicForm
                            widgets={ _form }
                            submitButton={ this.renderButton() }
                            onValidSubmit={ this._onValidSubmit.bind(this) }
                        />

                    </div>
                </div>
            </div>
        );
    }

    renderSuccess() {
        return (
            <div className="alert alert-success alert-block">
                <h4 className="alert-heading">Your message has been sent.</h4>
            </div>
        );
    }

    render() {

        return (
            <div>
                { this.state.hasSent ? this.renderSuccess() : this.renderForm() }
            </div>
        );
    }
}


React.render(<Contact />, document.getElementById('example'));
