
import BaseContainer from './base.js';
import classNames from 'classnames';


class Wrapper extends BaseContainer {
    render() {
        const outerClasses = classNames({
            'form-group': true,
            'has-error': !!this.props.errorMsg,
            [this.props.outerClasses]: !!this.props.outerClasses,
        });

        return (
            <div className={ outerClasses }>

				{ this.renderLabel() }
                <div className='row'>
                    { this.props.children }
                </div>
				{ this.renderError() }
				{ this.renderDescription() }

            </div>
        );
    }
}

export default Wrapper ;
