
import React from 'react/addons';
const PureRenderMixin = React.addons.PureRenderMixin;
import FormController from './formController.js';


class BasicForm extends FormController {

    constructor(props) {
        super(props);
        this.shouldComponentUpdate = PureRenderMixin.shouldComponentUpdate.bind(this);
    }

    render() {
        return (
            <form
                className={ this.props.formClasses }
                onSubmit={ this.onFormSubmit.bind(this) }
                noValidate={ true }>

                { this.traverseChildrenAndRegisterInputs(this.props.children) }

            </form>
        );
    }
}

BasicForm.propTypes = {
    submitButton: React.PropTypes.element,
    formClasses: React.PropTypes.string,
};

export default BasicForm;
