
// Valid error codes:
// client validation
// server validation
// payment failure

const ErrorCodes = {
    client: 'clientValidation',
    server: 'serverValidation',
};

/**
 * Error report, holds an instance of each error.
 *
 */
class ErrorReport {
    /**
     * Create an error report.
     *
     * The default format uses {fieldName} to substitude values.
     *
     * @param code The error code.
     * @param message The format to produce a string representation of the error.
     */
     //TODO: pass widget...so I can link to field?
    constructor(code, message, widget) {
        this.code = code;
        this.message = message;
    }

    toString() {
        return this.message;
    }

}


export default {
    ErrorReport,
    ErrorCodes,
};
