
import validators from './validators';


let _validators = {};
function registerValidator(name, validator) {
    _validators[name] = validator;
}

function registerDefaultValidators() {
    registerValidator('basicText', validators.LengthLimited);
    registerValidator('regex', validators.Regex);
    registerValidator('required', validators.Required);
    registerValidator('email', validators.Email);
}
registerDefaultValidators();


/**
 * Look up a validator, and create an instance of it.
 * @param name
 * @param options
 * @returns {*}
 */

function validatorByName(name) {
    const Val = _validators[name];

    if (!Val) {
        throw new Error('Unknown validation context name: ' + name);
    }

    return Val;
}

export default {
    validatorByName,
    registerValidator,
};
