
/**
 * ValidationResult is passed between validation contexts to accumulate errors.
 */
class ValidationResult {
    constructor(options) {
        this.errors = [];
        this.value = options.value;
    }

    addError(errorReport) {
        if (!errorReport) {
            throw new Error('Error report null on add.');
        }
        this.errors.push(errorReport);
    }

    isValid() {
        return this.errors.length === 0;
    }
}

export default ValidationResult;
