
import BaseValidationContext from './base.js';
import ValidationResult from '../result.js';


const emailRegEx = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;

/**
* The base validation context.
*/
class Email extends BaseValidationContext {

    runValidation(toTest) {
        let result = new ValidationResult({value: toTest});

        if (!emailRegEx.test(result.value)) {
            result.addError(
                this.clientError(`${this.label} is not a valid email.`)
            );
        }

        return Promise.resolve(result);
    }
}

export default Email;
