
import BaseInput from './base.js';
import classNames from 'classnames';


class ButtonGroup extends BaseInput {

	constructor(props) {
		super(props);
	}

	_updateFromDom() {
		let val = null;
        this.props.options.some( (o) => {
			const key = this._keyForChild(o);

			const isChecked = React.findDOMNode(this.refs[key]).checked;
			if (isChecked) {
				val = o.get('Value');
				return true;
			}

			return false;
		});

		return this._startValidation(val);
	}

	_keyForChild(child) {
		return name + '___' + child.get('Value') + '___' + child.get('Label');
	}

    renderComponent() {
        let options = this.props.options.map( o => {

			const name = this.props.name;
            const checked = this.state.value === o.get('Value');
			const key = this._keyForChild(o);

            const classes = classNames({
                'btn': true,
                'btn-default': true,
                'active': checked,
            });

            return (
				<label key={ key } className={ classes }>
                    <input
						type='radio'
						ref={ key }
                        value={ o.get('Value') }
                        name={ name }
                        id={ key }
                        onChange={ this._onChange.bind(this) }
                        defaultChecked={ checked }/>
					{ o.get('Label') }
				</label>
            );
        });

		return (
            <div className='btn-group' data-toggle='buttons'>
                { options }
            </div>
		);
	}
}

export default ButtonGroup;
