
import BaseInput from './base.js';


class CheckboxGroup extends BaseInput {

	constructor(props) {
		super(props);
	}

	_onChange(e) {
        let val = null;
        if ( e.target.checked ) {
            val = e.target.value;
        }
		this.setState({
			isPristene: false,
			value: val,
		});
		return this._startValidation(val);
	}

	_updateFromDom() {
        const child = this.props.options.first();
		const key = this._keyForChild(child);
		let val = null;

		if (React.findDOMNode(this.refs[key]).checked) {
			val = child.get('Value');
		}

		this.setState({
			value: val,
		});
		return this._startValidation(val);
	}

	_keyForChild(child) {
		return this.props.name + '___' + child.get('Value') + '___' + child.get('Label');
	}

	// NOTE: only getting the first as we only support 1 value per widget.
	renderComponent() {
        const child = this.props.options.first();
        const checked = this.state.value === child.get('Value');
		const key = this._keyForChild(child);
        const checks = (
            <div key={ key } className='checkbox'>
                <input
					ref={ key }
					id={ key }
					type='checkbox'
                    value={ child.get('Value') }
                    checked={ checked }
                    onChange={ this._onChange.bind(this) } />
				<label htmlFor={ key }>{ child.get('Label') }</label>
            </div>
        );

		return (
            <div className='controls'>
                { checks }
            </div>
		);
	}
}

export default CheckboxGroup;
