
import BaseInput from './base.js';
import classNames from 'classnames';


class DateInput extends BaseInput {

	constructor(props) {
		super(props);
	}

	_updateFromDom() {
		const val = React.findDOMNode(this.refs.input).value;
		return this._startValidation(val);
	}

    renderComponent() {
		const innerClasses = classNames({
			'form-control': true,
			[this.props.innerClasses]: !!this.props.innerClasses,
		});

        return (
			<input
				ref='input'
				className={ innerClasses }
				type={ this.props.type }
				name={ this.props.name }
				defaultValue={ this.props.value }
				onBlur={ this._onChange.bind(this) }
				placeholder={ this.props.placeholder }
			/>
        );

    }
}

export default DateInput;
