
import BaseInput from './base.js';
import classNames from 'classnames';


class Dropdown extends BaseInput {

	constructor(props) {
		super(props);
	}

	_updateFromDom() {
		const val = React.findDOMNode(this.refs.input).value;
		return this._startValidation(val);
	}

	// TODO: children should all be consistant...
    renderComponent() {
		const innerClasses = classNames({
			'form-control': true,
			[this.props.innerClasses]: !!this.props.innerClasses,
		});

        let options = this.props.options.map( o => {
			// TODO: the child value is weird...
			const key = o.get('Value') + '___' + o.get('Label');
            return (
                <option key={key} value={o.get('Value')}>{o.get('Label')}</option>
            );
        }).toArray();

		return (
            <select
				ref='input'
                className={ innerClasses }
				name={ this.props.name }
                defaultValue={ this.props.value }
                onChange={ this._onChange.bind(this) }
            >
                <option value=''> - select - </option>
                {options}
            </select>
		);
	}
}

export default Dropdown;
