
import BaseInput from './base.js';


class RadioGroup extends BaseInput {

	constructor(props) {
		super(props);
	}

	_updateFromDom() {
		let val = null;
        this.props.options.some( (o) => {
			const key = this._keyForChild(o);

			const isChecked = React.findDOMNode(this.refs[key]).checked;
			if (isChecked) {
				val = o.get('Value');
				return true;
			}

			return false;
		});

		return this._startValidation(val);
	}

	_keyForChild(child) {
		return this.props.name + '___' + child.get('Value') + '___' + child.get('Label');
	}

    renderComponent() {
        let options = this.props.options.map( o => {
			const name = this.props.name;
            const checked = this.props.value === o.get('Value');
			const key = this._keyForChild(o);

            return (
				<div key={ key } className='col-md-2 col-sm-3 col-xs-6'>
					<div className='radio'>
						<input
							type='radio'
							ref={ key }
							value={ o.get('Value') }
							name={ name }
							id={ key }
							onChange={ this._onChange.bind(this) }
							defaultChecked={ checked }/>
						<label htmlFor={ key }>{ o.get('Label') }</label>
					</div>
				</div>
            );
        });

		return (
            <div className='row'>
                { options }
            </div>
		);
	}
}

export default RadioGroup;
