
import BaseInput from './base.js';
import classNames from 'classnames';

class TextAreaInput extends BaseInput {

	constructor(props) {
		super(props);
	}

	_updateFromDom() {
		const val = React.findDOMNode(this.refs.input).value;
		return this._startValidation(val);
	}

    renderComponent() {
		const innerClasses = classNames({
			'form-control': true,
			[this.props.innerClasses]: !!this.props.innerClasses,
		});

        return (
			<textarea
				ref='input'
				rows='5'
                className={ innerClasses }
				type='text'
				name={ this.props.name }
				onBlur={ this._onChange.bind(this) }
				defaultValue={this.props.value}
				placeholder={ this.props.placeholder } />
        );

    }
}

export default TextAreaInput;
