'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var PureRenderMixin = _reactAddons2['default'].addons.PureRenderMixin;

var BaseContainer = (function (_React$Component) {
    _inherits(BaseContainer, _React$Component);

    function BaseContainer(props) {
        _classCallCheck(this, BaseContainer);

        _get(Object.getPrototypeOf(BaseContainer.prototype), 'constructor', this).call(this, props);
        this.shouldComponentUpdate = PureRenderMixin.shouldComponentUpdate.bind(this);
        this.state = { showError: null, showWarn: null, errors: null };
    }

    _createClass(BaseContainer, [{
        key: 'renderLabel',
        value: function renderLabel(extraClasses) {
            var _classNames;

            if (!this.props.label) {
                return '';
            }

            var labelClasses = (0, _classnames2['default'])((_classNames = {}, _defineProperty(_classNames, extraClasses, true), _defineProperty(_classNames, this.props.labelClasses, !!this.props.labelClasses), _classNames));

            return _reactAddons2['default'].createElement(
                'label',
                { className: labelClasses },
                this.props.label,
                this.props.isRequired ? _reactAddons2['default'].createElement(
                    'span',
                    { className: 'required' },
                    '*'
                ) : ''
            );
        }
    }, {
        key: 'renderError',
        value: function renderError() {
            var _this = this;

            if (!this.props.errorMsg) {
                return '';
            }

            var errors = [];

            // Convert to array.
            if (typeof this.props.errorMsg === 'object') {
                errors = Object.keys(this.props.errorMsg).map(function (k) {
                    return _this.props.errorMsg[k];
                });
            } else {
                errors = [this.props.errorMsg];
            }

            return _reactAddons2['default'].createElement(
                'ul',
                { className: 'parsley-errors-list filled' },
                errors.map(function (e, i) {
                    return _reactAddons2['default'].createElement(
                        'li',
                        { key: i },
                        e.toString()
                    );
                })
            );
        }
    }, {
        key: '_hasError',
        value: function _hasError() {
            if (!this.props.errorMsg) {
                return false;
            }

            if (typeof this.props.errorMsg === 'object') {
                return this.props.errorMsg.length > 0;
            }

            return !!this.props.errorMsg;
        }
    }, {
        key: 'renderDescription',
        value: function renderDescription() {
            if (!this.props.description) {
                return '';
            }

            return _reactAddons2['default'].createElement(
                'p',
                { className: 'help-block' },
                _reactAddons2['default'].createElement('small', {
                    dangerouslySetInnerHTML: { __html: this.props.description } })
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var outerClasses = (0, _classnames2['default'])(_defineProperty({
                'form-group': true
            }, this.props.outerClasses, !!this.props.outerClasses));

            return _reactAddons2['default'].createElement(
                'div',
                { className: outerClasses },
                this.renderLabel(),
                this.props.children,
                this.renderError(),
                this.renderDescription()
            );
        }
    }]);

    return BaseContainer;
})(_reactAddons2['default'].Component);

BaseContainer.propTypes = {
    type: _reactAddons2['default'].PropTypes.string,
    label: _reactAddons2['default'].PropTypes.string,
    description: _reactAddons2['default'].PropTypes.string,
    outerClasses: _reactAddons2['default'].PropTypes.string,
    labelClasses: _reactAddons2['default'].PropTypes.string,
    errorMsg: _reactAddons2['default'].PropTypes.oneOfType([_reactAddons2['default'].PropTypes.string, _reactAddons2['default'].PropTypes.array]),
    isRequired: _reactAddons2['default'].PropTypes.bool
};

exports['default'] = BaseContainer;
module.exports = exports['default'];

// 'control-label': true,
// 'has-error': this._hasError(),