'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _objectPath = require('object-path');

var _objectPath2 = _interopRequireDefault(_objectPath);

var PureRenderMixin = _reactAddons2['default'].addons.PureRenderMixin;

// TODO: also keypath...

var FormController = (function (_React$Component) {
    _inherits(FormController, _React$Component);

    function FormController(props) {
        _classCallCheck(this, FormController);

        _get(Object.getPrototypeOf(FormController.prototype), 'constructor', this).call(this, props);
        this.shouldComponentUpdate = PureRenderMixin.shouldComponentUpdate.bind(this);

        this.state = _immutable2['default'].fromJS({
            isValid: true,
            isValidating: false,
            errors: {}, // TODO: should I be in the widgets definition or internal to them.
            serverErrors: {}, // TODO: needs to be populated and displayed.
            hidden: {}, // The fields that have been hidden.
            disabled: {}
        });

        this._formData = _immutable2['default'].fromJS({
            isPristene: true, // Has any of the widgets been touched, or the form submitted.
            values: {}, // The values of the widgets.
            widgets: {},
            hasSubmitted: false });
    }

    _createClass(FormController, [{
        key: '_setIsValidating',

        // Set's the form to say validation has started, also set's the isValid to false.
        value: function _setIsValidating(isValidating) {
            var newState = { isValidating: isValidating };
            if (isValidating) {
                newState.isValid = false;
            }
            this.setState(newState);
        }
    }, {
        key: '_getIsValidating',
        value: function _getIsValidating() {
            return this.state.isValidating;
        }
    }, {
        key: 'onFormSubmit',

        // TODO: validation failed to complete?
        value: function onFormSubmit(e) {
            var _this = this;

            e.preventDefault();

            this._setIsValidating(true);

            var validations = [];

            // Get all the promises for validating each widget.
            this._formData.get('widgets').map(function (widget) {
                var q = widget._onSubmit().then(function (res) {
                    return res;
                });

                validations.push(q);
            }).toArray();

            // run all the validations
            Promise.all(validations).then(function (data) {
                _this._setIsValidating(false);

                // doing this inverse so it stops at the first invalid.
                var isInValid = data.some(function (d) {
                    return !d.isValid();
                });

                _this.setState({
                    hasSubmitted: true,
                    isPristene: false,
                    isValid: !isInValid
                });

                if (!isInValid) {
                    // If we are embedding the form.
                    if (_this.props.onValidSubmit) {
                        _this.props.onValidSubmit(_this._getValues());
                    }

                    // If we are directly sub-classing and we want the result.
                    if (_this._onValidSubmit) {
                        _this._onValidSubmit(_this._getValues());
                    }
                }
            })['catch'](function (err) {
                console.log(err, '<<<<<<< FORM validation failed');
            });
        }
    }, {
        key: '_onInputUpdate',
        value: function _onInputUpdate(w, result) {
            var name = w.props.name;

            if (result.isValid()) {
                this._formData = this._formData.setIn(['values'].concat(name.split('.')), result.value);
            }

            this._setNotPristene();
        }
    }, {
        key: '_setNotPristene',
        value: function _setNotPristene() {
            this._formData = this._formData.set('isPristene', false);
        }
    }, {
        key: '_getValues',
        value: function _getValues() {
            return this._formData.get('values').toJS();
        }
    }, {
        key: 'attatchToForm',

        /* hideErrors= !this.state.hasSubmitted  */

        value: function attatchToForm(w) {
            var name = w.props.name;
            this._formData = this._formData.setIn(['widgets', name], w);
        }
    }, {
        key: 'detatchFromForm',
        value: function detatchFromForm(w) {
            var name = w.props.name;
            this._formData = this._formData.deleteIn(['widgets', name], w);
            this._formData = this._formData.deleteIn(['values'].concat(name.split('.')), w);
        }
    }, {
        key: 'traverseChildrenAndRegisterInputs',
        value: function traverseChildrenAndRegisterInputs(children) {
            var _this2 = this;

            if (typeof children !== 'object' || children === null) {
                return children;
            }

            return _reactAddons2['default'].Children.map(children, function (child) {

                if (typeof child !== 'object' || child === null) {
                    return child;
                }

                if (child.props && child.props.name) {

                    return _reactAddons2['default'].cloneElement(child, {
                        formController: _this2
                    }, child.props && child.props.children);
                }

                return _reactAddons2['default'].cloneElement(child, {}, _this2.traverseChildrenAndRegisterInputs(child.props && child.props.children));
            });
        }
    }]);

    return FormController;
})(_reactAddons2['default'].Component);

//TODO: values:  initial values... get copied
FormController.propTypes = {
    onValidSubmit: _reactAddons2['default'].PropTypes.func
};

exports['default'] = FormController;
module.exports = exports['default'];
// Has the form been submitted.
// touchedFields: {},