'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _validators2 = require('./validators');

var _validators3 = _interopRequireDefault(_validators2);

var _validators = {};
function registerValidator(name, validator) {
    _validators[name] = validator;
}

function registerDefaultValidators() {
    registerValidator('basicText', _validators3['default'].LengthLimited);
    registerValidator('regex', _validators3['default'].Regex);
    registerValidator('required', _validators3['default'].Required);
    registerValidator('email', _validators3['default'].Email);
}
registerDefaultValidators();

/**
 * Look up a validator, and create an instance of it.
 * @param name
 * @param options
 * @returns {*}
 */

function validatorByName(name) {
    var Val = _validators[name];

    if (!Val) {
        throw new Error('Unknown validation context name: ' + name);
    }

    return Val;
}

exports['default'] = {
    validatorByName: validatorByName,
    registerValidator: registerValidator
};
module.exports = exports['default'];