'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _resultJs = require('./result.js');

var _resultJs2 = _interopRequireDefault(_resultJs);

var _lookupJs = require('./lookup.js');

var _validators = require('./validators');

// TODO: cancel validations?
// TODO: failed validations, server error 500

var Runner = (function () {
    function Runner(opts) {
        _classCallCheck(this, Runner);

        this.label = opts.label;
        this.result = null;
        this.rawValue = null;
        this.isRequired = false;

        this.validators = this._createValidators(opts.validators);
    }

    _createClass(Runner, [{
        key: 'setResult',
        value: function setResult(result) {
            this.result = result;
        }
    }, {
        key: 'getResult',
        value: function getResult() {
            return this.result;
        }
    }, {
        key: 'getIsRequired',
        value: function getIsRequired() {
            return this.isRequired;
        }
    }, {
        key: '_createValidators',
        value: function _createValidators(validators) {
            var _this = this;

            if (!validators) {
                return null;
            }

            return validators.map(function (validatorDef) {
                var Val = (0, _lookupJs.validatorByName)(validatorDef.name);
                if (Val === _validators.Required) {
                    _this.isRequired = true;
                }

                if (!validatorDef.label) {
                    validatorDef.label = _this.label;
                }

                return new Val(validatorDef);
            });
        }
    }, {
        key: '_shouldRunValidations',
        value: function _shouldRunValidations(val) {
            return val !== this.rawValue || !this.result;
        }
    }, {
        key: '_shouldSkipValidator',
        value: function _shouldSkipValidator(validator, result) {
            return validator.skipIfErrors && result.errors.length > 0;
        }
    }, {
        key: 'recursionBaby',
        value: function recursionBaby(validators, result, resolve, reject) {
            var _this2 = this;

            if (!validators || validators.length === 0) {
                return resolve(result);
            }

            var validator = validators[0];

            // Should we skip this validator?
            if (this._shouldSkipValidator(validator, result)) {
                return this.recursionBaby(validators.slice(1), result, resolve, reject);
            }

            return validator.runValidation(result.value).then(function (res) {
                // Modify our result object
                result.value = res.value;
                res.errors.map(function (e) {
                    return result.addError(e);
                });

                // If we need to stop if we find any errors.
                if (validator.breakOnError && result.errors.length > 0) {
                    return _this2.recursionBaby([], result, resolve, reject);
                }

                var endValidators = validators.slice(1);
                _this2.recursionBaby(endValidators, result, resolve, reject);
            })['catch'](function (err) {
                return reject(err);
            });
        }
    }, {
        key: 'runValidations',
        value: function runValidations(value) {
            var _this3 = this;

            // If there is no validators to run, just save the value.
            if (!this.validators) {
                var result = new _resultJs2['default']({ value: value });
                this.setResult(result);
                return Promise.resolve(result);
            }

            // Nothing has changed and we have already run the validation.
            if (!this._shouldRunValidations(value)) {
                // Return the existing validation result.
                return Promise.resolve(this.result);
            }

            // Save this to see if we should run the validations later.
            this.rawValue = value;

            return new Promise(function (resolve, reject) {
                var result = new _resultJs2['default']({ value: value });
                _this3.recursionBaby(_this3.validators, result, resolve, reject);
            }).then(function (res) {
                // After the validations have run, save the result.
                _this3.setResult(res);
                return res;
            });
        }
    }]);

    return Runner;
})();

exports['default'] = Runner;
module.exports = exports['default'];