'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _errorCodesJs = require('../errorCodes.js');

/**
 * The base validation context is not intended to be instanciated
 * directly but inherited from.
 */

var BaseValidationContext = (function () {
    function BaseValidationContext(options) {
        _classCallCheck(this, BaseValidationContext);

        this.skipIfErrors = options.skipIfErrors; // if any errors are found don't run this validaton.
        this.breakOnError = options.breakOnError; // once validation has run and an error is found don't run next validator.
        this.label = options.label; // The label to use in error msgs.
        this.msg = options.msg; // Over ride the default error msg.
    }

    _createClass(BaseValidationContext, [{
        key: 'runValidation',

        // NOTE: renaming this from apply as it's a reserved js word that is very confusting
        value: function runValidation(value) {
            throw new Error('runValidation must be over ridden:', value);
        }
    }, {
        key: 'clientError',
        value: function clientError(errorMsg) {
            // We can override it with a custom message.
            if (this.msg) {
                return new _errorCodesJs.ErrorReport(_errorCodesJs.ErrorCodes.client, this.msg);
            }

            return new _errorCodesJs.ErrorReport(_errorCodesJs.ErrorCodes.client, errorMsg);
        }

        // Do not extend this directly, extend one from the next level up!.

    }]);

    return BaseValidationContext;
})();

exports['default'] = BaseValidationContext;
module.exports = exports['default'];