'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _baseJs = require('./base.js');

var _baseJs2 = _interopRequireDefault(_baseJs);

var _resultJs = require('../result.js');

var _resultJs2 = _interopRequireDefault(_resultJs);

/**
* The base validation context.
*/

var BasicLimitedTextField = (function (_BaseValidationContext) {
    _inherits(BasicLimitedTextField, _BaseValidationContext);

    function BasicLimitedTextField(options) {
        _classCallCheck(this, BasicLimitedTextField);

        _get(Object.getPrototypeOf(BasicLimitedTextField.prototype), 'constructor', this).call(this, options);

        this.notShorter = options.notShorter;
        this.notLonger = options.notLonger;
        this.allowEmpty = options.allowEmpty;
        this.trim = options.trim;
    }

    _createClass(BasicLimitedTextField, [{
        key: 'runValidation',
        value: function runValidation(toTest) {
            var result = new _resultJs2['default']({ value: toTest });

            // If we are null then drop out, it can be picked up by the required validator.
            if (result.value === null) {
                return Promise.resolve(result);
            }

            // Trim result first before processing.
            // if (this.trim !== null && this.time === true) {
            if (this.trim) {
                result.value = result.value.trim();
            }

            if (this.allowEmpty !== null) {
                if (result.value.length === 0) {
                    result.addError(this.clientError(this.label + ' is empty'));
                }
            }

            if (this.notLonger !== null && result.value !== null && toTest.length > this.notLonger) {
                result.addError(this.clientError(this.label + ' is too long.'));
            }

            if (this.notShorter !== null && result.value !== null && toTest.length < this.notShorter) {
                result.addError(this.clientError(this.label + ' is too short.'));
            }

            return Promise.resolve(result);
        }
    }]);

    return BasicLimitedTextField;
})(_baseJs2['default']);

exports['default'] = BasicLimitedTextField;
module.exports = exports['default'];