'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _containers = require('../containers');

var _containers2 = _interopRequireDefault(_containers);

var _validation = require('../validation');

var PureRenderMixin = _reactAddons2['default'].addons.PureRenderMixin;

var BaseInput = (function (_React$Component) {
	_inherits(BaseInput, _React$Component);

	// TODO: convert this to use immutable

	function BaseInput(props) {
		_classCallCheck(this, BaseInput);

		_get(Object.getPrototypeOf(BaseInput.prototype), 'constructor', this).call(this, props);
		this.shouldComponentUpdate = PureRenderMixin.shouldComponentUpdate.bind(this);
		this.state = {
			isValidating: false,
			value: this.props.value,
			isPristine: true,
			errors: []

		};

		// using this as updating this doesn't cause a redraw.
		this.validator = new _validation.Runner({
			validators: this.props.validation,
			label: this.props.label
		});
	}

	_createClass(BaseInput, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			if (this.getFormController()) {
				this.getFormController().attatchToForm(this);
			}
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			if (this.getFormController()) {
				this.getFormController().detatchFromForm(this);
			}
		}
	}, {
		key: 'getFormController',

		// componentWillReceiveProps(nextProps) {
		// 	if (nextProps.value) {
		// 		this.setState({value: nextProps.value});
		// 	}
		// }

		value: function getFormController() {
			return this.props.formController;
		}
	}, {
		key: 'resetValue',
		value: function resetValue() {}
	}, {
		key: '_setValidating',

		// TODO: wrap all the setStates into 1
		value: function _setValidating(isValidating) {
			this.setState({ isValidating: isValidating });
		}
	}, {
		key: '_getValidating',
		value: function _getValidating() {
			return this.state.isValidating;
		}
	}, {
		key: '_startValidation',

		/**
   * Starts the validation process by trigger the chain of validators.
   * @param ev The event that is the source trigger for the validation.
   * Returns void.
   */

		value: function _startValidation(val) {
			var _this = this;

			// Be good to know if the validations are running.
			this._setValidating(true);

			// Run the validations.
			return this.validator.runValidations(val).then(function (res) {
				_this._setValidating(false);
				return _this._onValidationComplete(res);
			})['catch'](function (err) {
				console.log(err, '<<<<<< ERROR in base.jsx');
				_this._setValidating(false);
				throw new Error(err);
			});
		}
	}, {
		key: '_updateFormController',
		value: function _updateFormController() {
			var result = this.validator.getResult();
			if (this.getFormController()) {
				this.getFormController()._onInputUpdate(this, result);
			}

			if (this.props.onInputUpdate) {
				this.props.onInputUpdate(result);
			}
		}
	}, {
		key: '_onValidationComplete',

		/**
   * Called when validation has completed and after the _onValidationStart
   * promise has completed.
   * Override this to interpret the validation result in a context specific
   * way.
   *
   * Check result.
   *
   * @param result The validation result.
   * @private
   */
		value: function _onValidationComplete(result) {
			var _this2 = this;

			// TODO: remove this and just pass the result to the container.
			this.setState({
				errors: result.errors
			}, this._updateFormController);

			// Run any of the functions attached to this widget (update cart or conditional logic)
			if (this.props.onChangeFns) {
				setTimeout(function () {
					_this2.props.onChangeFns.forEach(function (fn) {
						fn(_this2.props.viewerIndex, _this2.props.name, result.value);
					});
				}, 0);
			}

			return result;
		}
	}, {
		key: '_onSubmit',
		value: function _onSubmit() {
			return this._updateFromDom();
		}
	}, {
		key: '_onChange',
		value: function _onChange(e) {
			var _this3 = this;

			var val = e.target.value;

			this.setState({
				'value': val,
				'isPristine': false
			}, function () {
				_this3._startValidation(val);
			});
		}
	}, {
		key: 'renderComponent',

		// Override me!
		value: function renderComponent() {
			return null;
		}
	}, {
		key: 'render',
		value: function render() {
			var Container = _containers2['default'].getForLayout(this.props.layout);
			return _reactAddons2['default'].createElement(
				Container,
				{
					label: this.props.label,
					description: this.props.description,
					outerClasses: this.props.outerClasses,
					labelClasses: this.props.labelClasses,
					isRequired: this.validator.getIsRequired(),
					errorMsg: this.state.errors
				},
				this.renderComponent()
			);
			// errorMsg={ this.props.errorMsg }
		}
	}]);

	return BaseInput;
})(_reactAddons2['default'].Component);

BaseInput.propTypes = {
	name: _reactAddons2['default'].PropTypes.string.isRequired,
	label: _reactAddons2['default'].PropTypes.string.isRequired,
	description: _reactAddons2['default'].PropTypes.string,
	value: _reactAddons2['default'].PropTypes.any,
	onInputUpdate: _reactAddons2['default'].PropTypes.func,
	formController: _reactAddons2['default'].PropTypes.object,
	onChangeFns: _reactAddons2['default'].PropTypes.array,
	layout: _reactAddons2['default'].PropTypes.string,

	validation: _reactAddons2['default'].PropTypes.array, // also only use of immutable

	// validation: React.PropTypes.instanceOf(Immutable.List), // also only use of immutable
	// validatorContext: React.PropTypes.instanceOf(BaseValidationContext),

	options: _reactAddons2['default'].PropTypes.instanceOf(_immutable2['default'].List), // This is the available children or options
	outerClasses: _reactAddons2['default'].PropTypes.string,
	innerClasses: _reactAddons2['default'].PropTypes.string,
	labelClasses: _reactAddons2['default'].PropTypes.string
};

BaseInput.defaultProps = {
	layout: 'single'
};

exports['default'] = BaseInput;
module.exports = exports['default'];
//   _isRequired: false,
//   _isValid: true,
//   _validationError: '',
//   _externalError: null,
//   _formSubmitted: false

// this.setState({value: this.validator.rawValue});

// TODO: find dom node and set value
// TODO: have a set value and get value for dom nodes?
// 	errorMsg: React.PropTypes.string,