'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _baseJs = require('./base.js');

var _baseJs2 = _interopRequireDefault(_baseJs);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _marty = require('marty');

var _marty2 = _interopRequireDefault(_marty);

var Donation = (function (_BaseInput) {
    _inherits(Donation, _BaseInput);

    function Donation(props) {
        var _this = this;

        _classCallCheck(this, Donation);

        _get(Object.getPrototypeOf(Donation.prototype), 'constructor', this).call(this, props);

        var showOther = this.props.options.filter(function (o) {
            return _this.props.value === o.get('Value');
        }).count() === 0;

        // In the case when nothing is selected, hide the other.
        if (!this.props.value) {
            showOther = false;
        }

        this.state = { showOther: showOther };
    }

    _createClass(Donation, [{
        key: '_onChange',
        value: function _onChange(e) {
            var _this2 = this;

            var val = e.target.value;
            if (val === 'Other') {
                this.setState({
                    showOther: true,
                    isPristene: false
                });
            } else {
                this.setState({
                    showOther: false,
                    isPristene: false
                });
                return this._startValidation(val);
            }

            // Start the cart reloading. Timeout makes sure that the value has updated
            // in other stores.
            if (this.props.onChangeFns) {
                setTimeout(function () {
                    _this2.props.onChangeFns.forEach(function (fn) {
                        fn(_this2.props.viewerIndex, _this2.props.name, val);
                    });
                }, 0);
            }
        }
    }, {
        key: '_onChangeOther',
        value: function _onChangeOther(e) {
            var val = e.target.value;
            this.setState({ isPristene: false });
            return this._startValidation(val);
        }
    }, {
        key: '_updateFromDom',
        value: function _updateFromDom() {
            var _this3 = this;

            var val = null;
            this.props.options.some(function (o) {
                var key = _this3._keyForChild(o);

                var isChecked = React.findDOMNode(_this3.refs[key]).checked;
                if (isChecked) {
                    val = o.get('Value');
                    return true;
                }

                return false;
            });

            if (val === 'Other') {
                val = React.findDOMNode(this.refs.other).value;
            }

            // Handle the null case.
            this.setState({ isPristene: false });
            return this._startValidation(val);
        }
    }, {
        key: '_keyForChild',
        value: function _keyForChild(child) {
            return this.props.name + '___' + child.get('Value') + '___' + child.get('Label');
        }
    }, {
        key: 'renderDonationOptions',
        value: function renderDonationOptions() {
            var _this4 = this;

            var options = this.props.options.map(function (o) {
                var key = _this4._keyForChild(o);

                var checked = _this4.props.value === o.get('Value');
                if (o.get('Value') === 'Other') {
                    checked = _this4.state.showOther;
                }

                return React.createElement(
                    'div',
                    { key: key, className: 'radio' },
                    React.createElement('input', {
                        type: 'radio',
                        ref: key,
                        id: key,
                        value: o.get('Value'),
                        name: _this4.props.name,
                        onChange: _this4._onChange.bind(_this4),
                        defaultChecked: checked
                    }),
                    React.createElement(
                        'label',
                        { htmlFor: key },
                        o.get('Label')
                    )
                );
            });

            return React.createElement(
                'div',
                { className: 'controls donation-group' },
                options
            );
        }
    }, {
        key: 'renderOther',
        value: function renderOther() {
            if (!this.state.showOther) {
                return null;
            }

            var outerClasses = (0, _classnames2['default'])({
                'form-group': true,
                'donation-other-holder': true
            });

            var name = this.props.name + '_other';

            return React.createElement(
                'div',
                { className: outerClasses },
                React.createElement(
                    'label',
                    { htmlFor: name },
                    'Other amount:'
                ),
                React.createElement(
                    'div',
                    { className: 'controls' },
                    React.createElement('input', {
                        id: name,
                        className: 'form-control',
                        ref: 'other',
                        name: name,
                        onBlur: this._onChangeOther.bind(this),
                        type: 'text',
                        placeholder: 'Enter amount',
                        defaultValue: this.props.value })
                )
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var outerClasses = (0, _classnames2['default'])({
                'form-group': true
            });
            var labelClasses = (0, _classnames2['default'])({
                'control-label': true,
                'col-sm-4': false
            });

            var description = undefined;
            if (this.props.description) {
                description = React.createElement(
                    'p',
                    { className: 'help-block' },
                    React.createElement(
                        'em',
                        null,
                        this.props.description
                    )
                );
            }

            return React.createElement(
                'div',
                { className: 'donation-show' },
                React.createElement(
                    'div',
                    { className: outerClasses },
                    React.createElement(
                        'label',
                        { className: labelClasses },
                        this.props.label,
                        this.props.isRequired ? React.createElement(
                            'span',
                            { className: 'required' },
                            '*'
                        ) : ''
                    ),
                    description,
                    this.renderDonationOptions(),
                    this.props.errorMsg ? React.createElement(
                        'span',
                        { className: 'help-block' },
                        this.props.errorMsg
                    ) : ''
                ),
                this.renderOther()
            );
        }
    }]);

    return Donation;
})(_baseJs2['default']);

exports['default'] = _marty2['default'].createContainer(Donation);
module.exports = exports['default'];
// 'has-error': this._showError(),
// 'has-error': this._showError(),